<?php
class ControllerPaymentParspal extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('payment/parspal');

		$this->document->setTitle($this->language->get('doc_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('parspal', $this->request->post);

			$this->session->data['Success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_apikey'] = $this->language->get('entry_apikey');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['apikey'])) {
			$data['error_apikey'] = $this->error['apikey'];
		} else {
			$data['error_apikey'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_payment'),
			'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('payment/parspal', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['action'] = $this->url->link('payment/parspal', 'token=' . $this->session->data['token'], 'SSL');

		$data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');

		if (isset($this->request->post['parspal_apikey'])) {
			$data['parspal_apikey'] = $this->request->post['parspal_apikey'];
		} else {
			$data['parspal_apikey'] = $this->config->get('parspal_apikey');
		}

		if (isset($this->request->post['parspal_order_status_id'])) {
			$data['parspal_order_status_id'] = $this->request->post['parspal_order_status_id'];
		} else {
			$data['parspal_order_status_id'] = $this->config->get('parspal_order_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['parspal_status'])) {
			$data['parspal_status'] = $this->request->post['parspal_status'];
		} else {
			$data['parspal_status'] = $this->config->get('parspal_status');
		}

		if (isset($this->request->post['parspal_sort_order'])) {
			$data['parspal_sort_order'] = $this->request->post['parspal_sort_order'];
		} else {
			$data['parspal_sort_order'] = $this->config->get('parspal_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/parspal.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'payment/parspal')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->request->post['parspal_apikey']) {
			$this->error['apikey'] = $this->language->get('error_apikey');
		}

		return !$this->error;
	}
}
?>