<?php
class ControllerPaymentParspal extends Controller {
	public function index() {
		$this->load->language('payment/parspal');
		
		$data['text_connect'] = $this->language->get('text_connect');
		$data['text_loading'] = $this->language->get('text_loading');
 		$data['text_wait'] = $this->language->get('text_wait');
		
		$data['button_confirm'] = $this->language->get('button_confirm');

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/parspal.tpl')) {
			return $this->load->view($this->config->get('config_template') . '/template/payment/parspal.tpl', $data);
		} else {
			return $this->load->view('default/template/payment/parspal.tpl', $data);
		}
	}

	public function confirm() {
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$this->load->library('encryption');
		$encryption = new Encryption($this->config->get('config_encryption'));

		$apikey = $this->config->get('parspal_apikey');

		$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		if($this->currency->getCode() == 'TOM') {
			$amount = $amount * 10;
		}

		$order_id_encripted = $encryption->encrypt($this->session->data['order_id']);
		$callbackUrl  =  $this->url->link('payment/parspal/callback', '', 'SSL');

        require_once(dirname(__FILE__) . '/parspal_api_helper.class.php');
		$papi = new ParsPal_API_Helper($apikey);
		$rapi = $papi->paymentRequest(array(
				'amount'      => $amount,
				'order_id'    => $order_info['order_id'],
                'reserve_id'  => $order_id_encripted,
				'description' => $order_info['comment'],
				'return_url'  => $callbackUrl,
                'currency'    => 'IRR',
				'payer'       => array(
				'name'        => $order_info['firstname'] .' ' . $order_info['lastname'],
				'email'       => $order_info['email'],
				'mobile'      => $order_info['telephone'],
		)));
		if ($rapi)
		{
			$paymentUrl = $papi->paymentUrl;
			$json = array();
			$json['success']= $paymentUrl;
			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput(json_encode($json));
		}
		else
		{
			$error_message = $papi->error;
            $this->CheckState($error_message);
		}
	}

	public function CheckState($status) {
		$json = array();
		$json['error'] = $status;
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function callback() {

			$this->load->language('payment/parspal');

			$this->document->setTitle($this->language->get('text_title'));
			
			$data['heading_title'] = $this->language->get('text_title');
			$data['text_results'] = $this->language->get('text_results');
			$data['results'] = "";

			$this->load->library('encryption');
			$encryption = new Encryption($this->config->get('config_encryption'));

			$apikey = $this->config->get('parspal_apikey');
			
			//breadcrumbs
			$data['breadcrumbs'] = array();
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_home'), 
				'href' => $this->url->link('common/home', '', 'SSL')
			);
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_title'), 
				'href' => $this->url->link('payment/parspal/callback', '', 'SSL')
			);

			$this->load->model('checkout/order');

            require_once(dirname(__FILE__) . '/parspal_api_helper.class.php');
    		$papi = new ParsPal_API_Helper($apikey);

            if($papi->checkStatusCode($this->request->post['status']))
            {
                if (isset($this->request->post['reserve_id'])) {
        			$order_id = $encryption->decrypt($this->request->post['reserve_id']);
        		} else {
        			$order_id = 0;
        		}
    			$order_info = $this->model_checkout_order->getOrder($order_id);

    			if ($order_info && $order_id == $this->request->post['order_id']) {

                   $amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);

        			if($this->currency->getCode() == 'TOM') {
        			    $amount = $amount * 10;
        		    }

                    $receipt_number = $this->request->post['receipt_number'];
                    $rapi = $papi->paymentVerify($receipt_number, $amount,'IRR');
                    if ($rapi)
                    {
                    	$comment = $this->language->get('text_results') . $receipt_number;
                		$this->model_checkout_order->addOrderHistory($order_id, $this->config->get('parspal_order_status_id'), $comment, true);

                		$data['error_warning'] = NULL;
                		$data['results'] = $receipt_number;
                		$data['button_continue'] = $this->language->get('button_complete');
                		$data['continue'] = $this->url->link('checkout/success');
                    }
                    else
                    {
                    	$data['error_warning'] = 'خطا در عملیات پردازش پرداخت:' . '<br>' . 'کد خطا:'.$papi->error;
                		$data['button_continue'] = $this->language->get('button_view_cart');
                		$data['continue'] = $this->url->link('checkout/cart');
                    }
                }
            }
            else
            {
                $data['error_warning'] = 'اطلاعات مبنی بر پرداخت موفق دریافت نشده است'.'<br>'.$papi->error;
				$data['button_continue'] = $this->language->get('button_view_cart');
				$data['continue'] = $this->url->link('checkout/cart');
            }

			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/parspal_confirm.tpl')) {
				$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/payment/parspal_confirm.tpl', $data));
			} else {
				$this->response->setOutput($this->load->view('default/template/payment/parspal_confirm.tpl', $data));
			}
	}
}
?>